common/models/User.php
<?php
namespace common\models;

use Yii;
use yii\base\NotSupportedException;
use yii\behaviors\TimestampBehavior;
use yii\db\ActiveRecord;
use yii\web\IdentityInterface;

/**
 * User model
 *
 * @property integer $id
 * @property string $username
 * @property string $password_hash
 * @property string $password_reset_token
 * @property string $email
 * @property string $auth_key
 * @property integer $status
 * @property integer $created_at
 * @property integer $updated_at
 * @property string $password write-only password
 */
class User extends ActiveRecord implements IdentityInterface
{
    const STATUS_DELETED = 0;
    const STATUS_ACTIVE = 10;


    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return '{{%user}}';
    }

    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            TimestampBehavior::className(),
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            ['status', 'default', 'value' => self::STATUS_ACTIVE],
            ['status', 'in', 'range' => [self::STATUS_ACTIVE, self::STATUS_DELETED]],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public static function findIdentity($id)
    {
        return static::findOne(['id' => $id, 'status' => self::STATUS_ACTIVE]);
    }

    /**
     * {@inheritdoc}
     */
    public static function findIdentityByAccessToken($token, $type = null)
    {
        throw new NotSupportedException('"findIdentityByAccessToken" is not implemented.');
    }

    /**
     * Finds user by username
     *
     * @param string $username
     * @return static|null
     */
    public static function findByUsername($username)
    {
        return static::findOne(['username' => $username, 'status' => self::STATUS_ACTIVE]);
    }

    /**
     * Finds user by password reset token
     *
     * @param string $token password reset token
     * @return static|null
     */
    public static function findByPasswordResetToken($token)
    {
        if (!static::isPasswordResetTokenValid($token)) {
            return null;
        }

        return static::findOne([
            'password_reset_token' => $token,
            'status' => self::STATUS_ACTIVE,
        ]);
    }

    /**
     * Finds out if password reset token is valid
     *
     * @param string $token password reset token
     * @return bool
     */
    public static function isPasswordResetTokenValid($token)
    {
        if (empty($token)) {
            return false;
        }

        $timestamp = (int) substr($token, strrpos($token, '_') + 1);
        $expire = Yii::$app->params['user.passwordResetTokenExpire'];
        return $timestamp + $expire >= time();
    }

    /**
     * {@inheritdoc}
     */
    public function getId()
    {
        return $this->getPrimaryKey();
    }

    /**
     * {@inheritdoc}
     */
    public function getAuthKey()
    {
        return $this->auth_key;
    }

    /**
     * {@inheritdoc}
     */
    public function validateAuthKey($authKey)
    {
        return $this->getAuthKey() === $authKey;
    }

    /**
     * Validates password
     *
     * @param string $password password to validate
     * @return bool if password provided is valid for current user
     */
    public function validatePassword($password)
    {
        return Yii::$app->security->validatePassword($password, $this->password_hash);
    }

    /**
     * Generates password hash from password and sets it to the model
     *
     * @param string $password
     * @throws \yii\base\Exception
     */
    public function setPassword($password)
    {
        $this->password_hash = Yii::$app->security->generatePasswordHash($password);
    }

    /**
     * Generates "remember me" authentication key
     */
    public function generateAuthKey()
    {
        $this->auth_key = Yii::$app->security->generateRandomString();
    }

    /**
     * Generates new password reset token
     */
    public function generatePasswordResetToken()
    {
        $this->password_reset_token = Yii::$app->security->generateRandomString() . '_' . time();
    }

    /**
     * Removes password reset token
     */
    public function removePasswordResetToken()
    {
        $this->password_reset_token = null;
    }
}

frontend/controllers/AddressController.php
<?php

namespace frontend\controllers;

use Yii;
use yii\filters\VerbFilter;
use yii\web\Controller;
use frontend\helpers\DropDownListHelper;
use frontend\models\User;
use frontend\models\Address;
use frontend\models\UserToAddress;
use frontend\helpers\QueryHelper;
use yii\web\NotFoundHttpException;

/**
 * Class AddressController
 * @package frontend\controllers
 */
class AddressController extends Controller
{
    /**
     * @return array
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['post'],
                ],
            ],
        ];
    }

    /**
     * @param int $usr
     * @return string|\yii\web\Response
     * @throws \yii\db\Exception
     */
    public function actionAdd($usr)
    {
        $userId = (int)strip_tags($usr);
        $address = new Address();
        $userToAddress = new UserToAddress();
        $trueMessage = 'Новый адрес успешно добавлен';

        $postAddressParams = Yii::$app->request->post('Address');
        $identicalAddress = $address->findIdenticalAddress($postAddressParams);

        if ($identicalAddress) {
            $identicalUserToAddress = $userToAddress->findIdenticalData($userId, $identicalAddress['id']);

            if (!$identicalUserToAddress) {
                $userToAddress->insertNewData($userId, $identicalAddress['id']);
                Yii::$app->session->setFlash('success', $trueMessage);
            } else {
                Yii::$app->session->setFlash('error', 'Данный адрес уже существует у пользователя');
            }

            return $this->refresh();
        } else {
            $transaction = Yii::$app->db->beginTransaction();

            try {
                if ($address->load(Yii::$app->request->post()) && $address->save()) {
                    $userToAddress->insertNewData($userId, $address->id);
                    $transaction->commit();
                    Yii::$app->session->setFlash('success', $trueMessage);

                    return $this->refresh();
                }
            } catch (\Exception $exception) {
                $transaction->rollback();
                Yii::$app->session->setFlash('error', 'Не удалось добавить новый адрес');
            }
        }

        $countryCodeList = DropDownListHelper::getCountryCodeList();

        return $this->render('add', [
            'userId' => $userId,
            'address' => $address,
            'countryCodeList' => $countryCodeList
        ]);
    }

    /**
     * @param int $usr
     * @param int $id
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException
     * @throws \yii\db\Exception
     */
    public function actionEdit($usr, $id)
    {
        $userId = (int)strip_tags($usr);
        $addressId = (int)strip_tags($id);
        $address = Address::findOne($addressId);
        (new QueryHelper())->checkQuery($address);

        $userToAddress = new UserToAddress();
        $trueMessage = 'Адрес успешно отредактирован';

        $postAddressParams = Yii::$app->request->post('Address');
        $identicalAddress = $address->findIdenticalAddress($postAddressParams);

        if ($identicalAddress) {
            $identicalUserToAddress = $userToAddress->findIdenticalData($userId, $identicalAddress['id']);

            if (!$identicalUserToAddress) {
                $userToAddress->insertNewData($userId, $identicalAddress['id']);
                Yii::$app->session->setFlash('success', $trueMessage);
            } else {
                Yii::$app->session->setFlash('error', 'Данный адрес уже существует у пользователя');
            }

            return $this->refresh();
        } else {
            if ($address->load(Yii::$app->request->post()) && $address->save()) {
                Yii::$app->session->setFlash('success', $trueMessage);

                return $this->refresh();
            }
        }

        $countryCodeList = DropDownListHelper::getCountryCodeList();

        return $this->render('edit', [
            'userId' => $userId,
            'address' => $address,
            'countryCodeList' => $countryCodeList
        ]);
    }

    /**
     * @param int $usr
     * @param int $id
     * @return \yii\web\Response
     * @throws NotFoundHttpException
     * @throws \Throwable
     * @throws \yii\db\Exception
     */
    public function actionDelete($usr, $id)
    {
        $userId = (int)strip_tags($usr);
        $addressId = (int)strip_tags($id);
        $address = Address::findOne($addressId);
        (new QueryHelper())->checkQuery($address);

        $transaction = Yii::$app->db->beginTransaction();

        try {
            if (count(User::findOne($userId)->getAddresses()) <= 1) {
                Yii::$app->session->setFlash('error', 'У пользователя должен быть минимум один адрес');

                return $this->redirect(Yii::$app->request->referrer);
            }

            $address->delete();
            $transaction->commit();

            Yii::$app->session->setFlash('success', 'Адрес успешно удален');
        } catch (\Exception $exception) {
            $transaction->rollback();
            Yii::$app->session->setFlash('error', 'Не удалось удалить адрес');
        }

        return $this->redirect(['user/view', 'id' => $userId]);
    }
}

frontend/controllers/UserController.php
<?php

namespace frontend\controllers;

use Yii;
use yii\filters\VerbFilter;
use yii\helpers\ArrayHelper;
use frontend\helpers\PaginationHelper;
use frontend\helpers\DropDownListHelper;
use yii\web\Controller;
use frontend\models\User;
use frontend\models\Address;
use frontend\models\UserToAddress;
use frontend\helpers\QueryHelper;
use yii\web\NotFoundHttpException;

/**
 * Class UserController
 * @package frontend\controllers
 */
class UserController extends Controller
{
    /**
     * @return array
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['post'],
                ],
            ],
        ];
    }

    /**
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException
     */
    public function actionIndex()
    {
        $users = User::find()->orderBy(['created_at' => SORT_DESC]);
        (new QueryHelper())->checkQuery($users);

        $paginationData = (new PaginationHelper())->createPagination(
            $users,
            Yii::$app->params['pageSizeForUserList']
        );
        $userList = $paginationData['dataList'];
        $pages = $paginationData['pages'];

        return $this->render('index', [
            'userList' => $userList,
            'pages' => $pages
        ]);
    }

    /**
     * @param int $id
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException
     */
    public function actionView($id)
    {
        $id = (int)strip_tags($id);
        $user = User::findOne($id);
        (new QueryHelper())->checkQuery($user);

        $addressesIds = ArrayHelper::getColumn($user->getAddresses(), 'id');
        $addresses = Address::find()->where(['in', 'id', $addressesIds]);

        $paginationData = (new PaginationHelper())->createPagination(
            $addresses,
            Yii::$app->params['pageSizeForUserAddressesList']
        );
        $addressList = $paginationData['dataList'];
        $pages = $paginationData['pages'];

        return $this->render('view', [
            'user' => $user,
            'addressList' => $addressList,
            'pages' => $pages
        ]);
    }

    /**
     * @return string|\yii\web\Response
     * @throws \yii\base\Exception
     * @throws \yii\db\Exception
     */
    public function actionAdd()
    {
        $user = new User();
        $user->gender = User::GENDER_NO_INFORMATION;
        $address = new Address();
        $trueMessage = 'Новый пользователь успешно добавлен';

        $postAddressParams = Yii::$app->request->post('Address');
        $identicalAddress = $address->findIdenticalAddress($postAddressParams);

        if ($identicalAddress) {
            if ($user->load(Yii::$app->request->post()) && $address->load(Yii::$app->request->post()) && $user->save()) {
                (new UserToAddress())->insertNewData($user->id, $identicalAddress['id']);
                Yii::$app->session->setFlash('success', $trueMessage);

                return $this->refresh();
            }
        }

        $transaction = Yii::$app->db->beginTransaction();

        try {
            if ($user->load(Yii::$app->request->post()) && $address->load(Yii::$app->request->post()) && $user->save() && $address->save()) {
                (new UserToAddress())->insertNewData($user->id, $address->id);
                $transaction->commit();
                Yii::$app->session->setFlash('success', $trueMessage);

                return $this->refresh();
            }
        } catch (\Exception $exception) {
            $transaction->rollback();
            $user->password = '';
            $user->password_repeat = '';
            Yii::$app->session->setFlash('error', 'Не удалось добавить нового пользователя');
        }

        $countryCodeList = DropDownListHelper::getCountryCodeList();

        return $this->render('add', [
            'user' => $user,
            'address' => $address,
            'countryCodeList' => $countryCodeList
        ]);
    }

    /**
     * @param int $id
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException
     */
    public function actionEdit($id)
    {
        $id = (int)strip_tags($id);
        $user = User::findOne($id);
        (new QueryHelper())->checkQuery($user);
        $user->password = '';

        if ($user->load(Yii::$app->request->post()) && $user->save()) {
            Yii::$app->session->setFlash('success', 'Данные пользователя успешно отредактированы');

            return $this->refresh();
        }

        return $this->render('edit', ['user' => $user]);
    }

    /**
     * @param int $id
     * @return \yii\web\Response
     * @throws \Throwable
     * @throws \yii\db\Exception
     */
    public function actionDelete($id)
    {
        $id = (int)strip_tags($id);
        $user = User::findOne($id);
        (new QueryHelper())->checkQuery($user);

        $transaction = Yii::$app->db->beginTransaction();

        try {
            foreach ($user->getAddresses() as $address) {
                if ((count($addressId = (new UserToAddress())->getIdByAddressId($address->id)) - 1) === 0) {
                    (new QueryHelper())->checkQuery($addressId);
                    Address::findOne($address->id)->delete();
                }
            }

            $user->delete();

            $transaction->commit();

            Yii::$app->session->setFlash('success', 'Пользователь успешно удален');
        } catch (\Exception $exception) {
            $transaction->rollback();
            Yii::$app->session->setFlash('error', 'Не удалось удалить пользователя');
        }

        return $this->redirect(['user/index']);
    }
}

frontend/views/user/add.php
<?php

/* @var $countryCodeList array */
/* @var $this yii\web\View */
/* @var $form yii\widgets\ActiveForm */
/* @var $user frontend\models\User */
/* @var $address frontend\models\Address */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;

$this->title = 'Добавить нового пользователя';
$this->params['breadcrumbs'][] = $this->title;
?>
<br>
<h1 class="text-center"><?= Html::encode($this->title) ?></h1>
<br>
<br>
<div class="col-md-6 col-md-offset-3">
    <?php $form = ActiveForm::begin(); ?>
        <?= $form->field($user, 'login') ?>
        <?= $form->field($user, 'email') ?>
        <?= $form->field($user, 'password')->passwordInput() ?>
        <?= $form->field($user, 'password_repeat')->passwordInput() ?>
        <?= $form->field($user, 'first_name') ?>
        <?= $form->field($user, 'last_name') ?>
        <?= $form->field($user, 'gender')->radioList($user->getGenderList(), ['class' => 'radio-inline']) ?>
        <br>
        <h3 class="text-center">Адрес пользователя</h3>
        <?= $form->field($address, 'postcode') ?>
        <?= $form->field($address, 'country_code_id')->dropDownList($countryCodeList, ['prompt' => '']) ?>
        <?= $form->field($address, 'city') ?>
        <?= $form->field($address, 'street') ?>
        <?= $form->field($address, 'house_number') ?>
        <?= $form->field($address, 'apartment_number') ?>
        <br>
        <?= Html::submitButton('Сохранить', ['class' => 'btn btn-primary']); ?>
    <?php ActiveForm::end(); ?>
    <br>
</div>

frontend/views/user/edit.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\widgets\ActiveForm */
/* @var $user frontend\models\User */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;

$this->title = "Редактировать данные пользователя (ID: {$user->id})";
$this->params['breadcrumbs'][] = $this->title;
?>
<br>
<h1 class="text-center col-md-6 col-md-offset-3"><?= Html::encode($this->title) ?></h1>
<br>
<br>
<div class="col-md-6 col-md-offset-3">
    <?php $form = ActiveForm::begin(); ?>
        <?= $form->field($user, 'login') ?>
        <?= $form->field($user, 'email') ?>
        <?= $form->field($user, 'password')->passwordInput() ?>
        <?= $form->field($user, 'password_repeat')->passwordInput() ?>
        <?= $form->field($user, 'first_name') ?>
        <?= $form->field($user, 'last_name') ?>
        <?= $form->field($user, 'gender')->radioList($user->getGenderList(), ['class' => 'radio-inline']) ?>
        <br>
        <?= Html::submitButton('Сохранить', ['class' => 'btn btn-primary']); ?>
    <?php ActiveForm::end(); ?>
    <br>
</div>

frontend/views/user/index.php
<?php

/* @var $this yii\web\View */
/* @var $pages yii\data\Pagination */
/* @var $userList[] frontend\models\User */

use yii\helpers\Html;
use yii\widgets\LinkPager;

$this->title = 'Список всех пользователей';
?>
<br>
<h1 class="text-center"><?= Html::encode($this->title) ?></h1>
<br>
<div class="text-right">
    <?= Html::a('Добавить нового пользователя', ['user/add'], [
        'class' => 'btn btn-lg btn-success',
    ]) ?>
</div>
<hr>
<?php foreach ($userList as $user) : ?>
    <div>
        <p class="h3 text-center text-primary col-lg-12">Пользователь (ID: <?= Html::encode($user->id) ?>)</p>
        <br>
        <div class="lead">
            <div class="col-lg-6 text-center">
                <p>Логин: <span class="text-muted"><?= Html::encode($user->login) ?></span></p>
                <p>Email: <span class="text-muted"><?= Html::encode($user->email) ?></span></p>
                <p>Пол: <span class="text-muted"><?= Html::encode($user->getGenderValue($user->gender)) ?></span></p>
                <p>Дата создания: <span class="text-muted"><?= Html::encode($user->getFormatCreatedAt($user->created_at)) ?></span></p>
            </div>
            <div class="col-lg-6 text-center">
                <p>Имя: <span class="text-muted"><?= Html::encode($user->first_name) ?></span></p>
                <p>Фамилия: <span class="text-muted"><?= Html::encode($user->last_name) ?></span></p>
                <p>Количество адресов: <span class="text-muted"><?= count($user->getAddresses()) ?></span></p>
            </div>
        </div>
        <div class="col-lg-12 text-right">
            <?= Html::a('Просмотреть', ['user/view', 'id' => Html::encode($user->id)], [
                'class' => 'btn btn-info',
            ]) ?>
            <?= Html::a('Редактировать', ['user/edit', 'id' => Html::encode($user->id)], [
                'class' => 'btn btn-primary',
            ]) ?>
            <?= Html::a('Удалить', ['user/delete', 'id' => Html::encode($user->id)], [
                'class' => 'btn btn-danger',
                'data-confirm' => 'Вы уверены, что хотите удалить данного пользователя?',
                'data-method' => 'post',
            ]) ?>
        </div>
        <hr class="col-lg-12">
    </div>
<?php endforeach; ?>
<div class="col-lg-12 text-center">
    <?= LinkPager::widget([
        'pagination' => $pages,
        'prevPageLabel' => 'Предыдущая',
        'nextPageLabel' => 'Следующая',
        'options' => ['class' => 'pagination pagination-lg'],
    ]); ?>
</div>

frontend/views/user/view.php
<?php

/* @var $this yii\web\View */
/* @var $pages yii\data\Pagination */
/* @var $user frontend\models\User */
/* @var $addressList[] frontend\models\Address */

use yii\helpers\Html;
use yii\widgets\LinkPager;

$this->title = "Просмотр информации о пользователе (ID: {$user->id})";
$this->params['breadcrumbs'][] = $this->title;
?>
<br>
<h1 class="text-center"><?= Html::encode($this->title) ?></h1>
<br>
<div class="text-right">
    <?= Html::a('Добавить новый адрес', ['address/add', 'usr' => Html::encode($user->id)], [
        'class' => 'btn btn-lg btn-success',
    ]) ?>
</div>
<hr>
<div>
    <br>
    <div class="lead">
        <div class="col-lg-6 text-center">
            <p>Логин: <span class="text-muted"><?= Html::encode($user->login) ?></span></p>
            <p>Email: <span class="text-muted"><?= Html::encode($user->email) ?></span></p>
            <p>Дата создания: <span class="text-muted"><?= Html::encode($user->getFormatCreatedAt($user->created_at)) ?></span></p>
        </div>
        <div class="col-lg-6 text-center">
            <p>Имя: <span class="text-muted"><?= Html::encode($user->first_name) ?></span></p>
            <p>Фамилия: <span class="text-muted"><?= Html::encode($user->last_name) ?></span></p>
            <p>Пол: <span class="text-muted"><?= Html::encode($user->getGenderValue($user->gender)) ?></span></p>
        </div>
        <br>
    </div>
    <br><br><br>
    <p class="h3 text-center text-primary">Адрес<?= count($user->getAddresses()) > 1 ? 'а' : '' ?> пользователя</p>
    <br>
    <?php foreach ($addressList as $address) : ?>
        <table class="table table-bordered text-center">
            <thead>
            <tr>
                <th class="text-center">ID</th>
                <th class="text-center">Почтовый индекс</th>
                <th class="text-center">Код страны</th>
                <th class="text-center">Название города</th>
                <th class="text-center">Название улицы</th>
                <th class="text-center">Номер дома</th>
                <th class="text-center">Номер офиса/квартиры</th>
            </tr>
            </thead>
            <tbody>
                <tr>
                    <td><?= Html::encode($address->id) ?></td>
                    <td><?= Html::encode($address->postcode) ?></td>
                    <td><?= Html::encode($address->getCountry()->country_code) ?></td>
                    <td><?= Html::encode($address->city) ?></td>
                    <td><?= Html::encode($address->street) ?></td>
                    <td><?= Html::encode($address->house_number) ?></td>
                    <td><?= Html::encode($address->apartment_number) ?></td>
                </tr>
            </tbody>
        </table>
        <div class="text-right">
            <?= Html::a('Редактировать', [
                'address/edit',
                'usr' => Html::encode($user->id),
                'id' => Html::encode($address->id)
            ], [
                'class' => 'btn btn-primary',
            ]) ?>
            <?= Html::a('Удалить', [
                'address/delete',
                'usr' => Html::encode($user->id),
                'id' => Html::encode($address->id)
            ], [
                'class' => 'btn btn-danger',
                'data-confirm' => 'Вы уверены, что хотите удалить данного пользователя?',
                'data-method' => 'post',
            ]) ?>
        </div>
        <br>
        <hr>
        <br>
    <?php endforeach; ?>
</div>
<div class="text-center">
    <?= LinkPager::widget([
        'pagination' => $pages,
        'prevPageLabel' => 'Предыдущая',
        'nextPageLabel' => 'Следующая',
        'options' => ['class' => 'pagination pagination-lg'],
    ]); ?>
</div>